spool 3_3_4_DissenyFisic_CreacioTaules.log

-- Taules necessries per l'aplicaci

CREATE TABLE AMBITS 
  (ID VARCHAR2(1 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(20 BYTE), 
    CONSTRAINT AMBITS_PK PRIMARY KEY (ID));
     
CREATE TABLE CATEGORIES
  (ID NUMBER(1,0) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(20 BYTE), 
    CONSTRAINT CATEGORIES_PK PRIMARY KEY (ID));
   
CREATE TABLE ESTATS
  (ID VARCHAR2(2 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(20 BYTE), 
    CONSTRAINT ESTATS_PK PRIMARY KEY (ID));

CREATE TABLE GENERES
  (ID VARCHAR2(1 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(20 BYTE), 
    CONSTRAINT GENERES_PK PRIMARY KEY (ID));
  
CREATE TABLE IND_ACTIVITAT
  (ID VARCHAR2(1 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(20 BYTE), 
    CONSTRAINT IND_ACTIVITAT_PK PRIMARY KEY (ID));
   
CREATE TABLE MODALITATS
  (ID VARCHAR2(2 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(40 BYTE), 
    CONSTRAINT MODALITATS_PK PRIMARY KEY (ID));
   
CREATE TABLE MONEDES
  (ID VARCHAR2(3 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(40 BYTE), 
    CONSTRAINT MONEDES_PK PRIMARY KEY (ID));

CREATE TABLE NACIONALITATS
  (ID VARCHAR2(3 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(40 BYTE), 
    CONSTRAINT NACIONALITATS_PK PRIMARY KEY (ID));

CREATE TABLE PAISOS_CONTINENTS
  (ID VARCHAR2(3 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(50 BYTE), 
    CONSTRAINT PAISOS_CONTINENTS_PK PRIMARY KEY (ID));
   
CREATE TABLE POSICIONS
  (ID NUMBER(1,0) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(20 BYTE), 
    CONSTRAINT POSICIONS_PK PRIMARY KEY (ID));

CREATE TABLE REPRESENTANTS_EQUIPS
  (ID VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   NOM VARCHAR2(100 BYTE), 
    CONSTRAINT REPRESENTANTS_EQUIPS_PK PRIMARY KEY (ID));
   
CREATE TABLE REPRESENTANTS_JUGADORS
  (ID VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   NOM VARCHAR2(100 BYTE), 
    CONSTRAINT REPRESENTANTS_JUGADORS_PK PRIMARY KEY (ID));
   
CREATE TABLE SUB_ESTATS
  (ID VARCHAR2(2 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(50 BYTE), 
    CONSTRAINT SUB_ESTATS_PK PRIMARY KEY (ID));
   
CREATE TABLE TIPUS_ARBITRES
  (ID NUMBER(1,0) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(40 BYTE), 
    CONSTRAINT TIPUS_ARBITRES_PK PRIMARY KEY (ID));
   
CREATE TABLE TIPUS_SOCIETATS
  (ID VARCHAR2(4 BYTE) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(50 BYTE), 
    CONSTRAINT TIPUS_SOCIETATS_PK PRIMARY KEY (ID));
   
CREATE TABLE TIPUS_TECNICS
  (ID NUMBER(1,0) NOT NULL ENABLE, 
   DESCRIPCIO VARCHAR2(40 BYTE), 
    CONSTRAINT TIPUS_TECNICS_PK PRIMARY KEY (ID));

CREATE TABLE ARBITRES 
  (ID VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   NOM VARCHAR2(100 BYTE), 
   TIPUS NUMBER(1,0), 
    CONSTRAINT ARBITRES_PK PRIMARY KEY (ID),
    CONSTRAINT ARBITRES_FK1 FOREIGN KEY (TIPUS)
    REFERENCES TIPUS_ARBITRES (ID) ENABLE);
   
CREATE TABLE EQUIPS 
  (ID VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   NOM VARCHAR2(100 BYTE),
   MUNICIPI VARCHAR2(50 BYTE), 
   PAIS VARCHAR2(3 BYTE), 
   ADREA VARCHAR2(100 BYTE), 
   TELEFON VARCHAR2(20 BYTE), 
   URL VARCHAR2(100 BYTE), 
   IND_SOC_CLUB VARCHAR2(1 BYTE), -- S: Societat y C: Club
   TIPUS_SOCIETAT VARCHAR2(4 BYTE), 
   NUM_SOCIS NUMBER(10,0) DEFAULT 0, 
    CONSTRAINT EQUIPS_PK PRIMARY KEY (ID),
    CONSTRAINT EQUIPS_FK1 FOREIGN KEY (PAIS)
     REFERENCES PAISOS_CONTINENTS (ID) ENABLE,  
    CONSTRAINT EQUIPS_FK2 FOREIGN KEY (TIPUS_SOCIETAT)
     REFERENCES TIPUS_SOCIETATS (ID) ENABLE);
   
CREATE TABLE EQUIPS_REPRESENTANTS
  (EQUIPS VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   REPRESENTANT VARCHAR2(20 BYTE) NOT NULL ENABLE, 
    CONSTRAINT EQUIPS_REPRESENTANTS_PK PRIMARY KEY (EQUIPS, REPRESENTANT),
    CONSTRAINT EQUIPS_REPRESENTANTS_FK1 FOREIGN KEY (REPRESENTANT)
     REFERENCES REPRESENTANTS_EQUIPS (ID) ENABLE, 
    CONSTRAINT EQUIPS_REPRESENTANTS_FK2 FOREIGN KEY (EQUIPS)
     REFERENCES EQUIPS (ID) ENABLE);
   
CREATE TABLE JUGADORS
  (ID VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   NACIONALITAT VARCHAR2(3 BYTE), 
   FEDERACIO VARCHAR2(3 BYTE), 
   NUM_FEDERAT NUMBER(15,0), 
   NOM VARCHAR2 (100 BYTE), 
   SEXE VARCHAR2 (1 BYTE),
   DATA_NAIXEMENT DATE,  
   ALADA NUMBER(5,2), 
   PES NUMBER(5,2), 
   POSICIO NUMBER(1,0),  
   URL_PERSONAL VARCHAR2(100 BYTE), 
   URL_PROMOCIO VARCHAR2(100 BYTE), 
   IND_ACTIVITAT VARCHAR2(1 BYTE) DEFAULT 'A', 
   ESTAT VARCHAR2(1 BYTE) DEFAULT 'A', 
   SUB_ESTAT VARCHAR2(2 BYTE), 
   DATA_DISP_ESTIMADA DATE, 
    CONSTRAINT JUGADORS_PK PRIMARY KEY (ID),
    CONSTRAINT JUGADORS_FK1 FOREIGN KEY (SEXE)
     REFERENCES GENERES (ID) ENABLE, 
    CONSTRAINT JUGADORS_FK2 FOREIGN KEY (ESTAT)
     REFERENCES ESTATS (ID) ENABLE, 
    CONSTRAINT JUGADORS_FK3 FOREIGN KEY (IND_ACTIVITAT)
     REFERENCES IND_ACTIVITAT (ID) ENABLE, 
    CONSTRAINT JUGADORS_FK4 FOREIGN KEY (NACIONALITAT)
     REFERENCES NACIONALITATS (ID) ENABLE, 
    CONSTRAINT JUGADORS_FK5 FOREIGN KEY (FEDERACIO)
     REFERENCES PAISOS_CONTINENTS (ID) ENABLE, 
    CONSTRAINT JUGADORS_FK6 FOREIGN KEY (POSICIO)
     REFERENCES POSICIONS (ID) ENABLE,  
    CONSTRAINT JUGADORS_FK7 FOREIGN KEY (SUB_ESTAT)
     REFERENCES SUB_ESTATS (ID) ENABLE);

CREATE TABLE JUGADORS_EQUIPS
  (JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   EQUIP VARCHAR2(20 BYTE) NOT NULL ENABLE, 
    CONSTRAINT JUGADORS_EQUIPS_PK PRIMARY KEY (JUGADOR, EQUIP),
    CONSTRAINT JUGADORS_EQUIPS_FK1 FOREIGN KEY (JUGADOR)
     REFERENCES JUGADORS (ID) ENABLE, 
    CONSTRAINT JUGADORS_EQUIPS_FK2 FOREIGN KEY (EQUIP)
     REFERENCES EQUIPS (ID) ENABLE);
    
CREATE TABLE JUGADORS_REPRESENTANTS
  (JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   REPRESENTANT VARCHAR2(20 BYTE) NOT NULL ENABLE, 
    CONSTRAINT JUGADORS_REPRESENTANTS_PK PRIMARY KEY (JUGADOR, REPRESENTANT),
    CONSTRAINT JUGADORS_REPRESENTANTS_FK1 FOREIGN KEY (JUGADOR)
     REFERENCES JUGADORS (ID) ENABLE, 
    CONSTRAINT JUGADORS_REPRESENTANTS_FK2 FOREIGN KEY (REPRESENTANT)
     REFERENCES REPRESENTANTS_JUGADORS (ID) ENABLE);

CREATE TABLE COMPETICIONS 
  (ID NUMBER(15,0), 
   NOM VARCHAR2(50 BYTE), 
   AMBIT VARCHAR2(1 BYTE) NOT NULL ENABLE, 
   GENERE VARCHAR2(1 BYTE) NOT NULL ENABLE, 
   MODALITAT VARCHAR2(2 BYTE) NOT NULL ENABLE, 
   PAIS_CONTINENT VARCHAR2(3 BYTE) NOT NULL ENABLE, 
   NUM_ARBITRES NUMBER(1,0), 
   CATEGORIA NUMBER(1,0) NOT NULL ENABLE, 
   TEMPORADA VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   FACTOR_PONDERACIO NUMBER(2,0) DEFAULT 0, 
    CONSTRAINT COMPETICIONS_PK PRIMARY KEY (AMBIT, GENERE, MODALITAT, PAIS_CONTINENT, CATEGORIA, TEMPORADA),
    CONSTRAINT COMPETICIONS_FK1 FOREIGN KEY (AMBIT)
     REFERENCES AMBITS (ID) ENABLE, 
    CONSTRAINT COMPETICIONS_FK2 FOREIGN KEY (CATEGORIA)
     REFERENCES CATEGORIES (ID) ENABLE, 
    CONSTRAINT COMPETICIONS_FK3 FOREIGN KEY (GENERE)
     REFERENCES GENERES (ID) ENABLE, 
    CONSTRAINT COMPETICIONS_FK4 FOREIGN KEY (MODALITAT)
     REFERENCES MODALITATS (ID) ENABLE, 
    CONSTRAINT COMPETICIONS_FK5 FOREIGN KEY (PAIS_CONTINENT)
     REFERENCES PAISOS_CONTINENTS (ID) ENABLE);

CREATE TABLE BAIXES_MEDIQUES
  (JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
	 DATA_INICI DATE NOT NULL ENABLE, 
	 DATA_FI DATE, 
	 DIAGNOSTIC VARCHAR2(1024 BYTE), 
	  CONSTRAINT BAIXES_MEDIQUES_PK PRIMARY KEY (JUGADOR, DATA_INICI),
	  CONSTRAINT BAIXES_MEDIQUES_FK1 FOREIGN KEY (JUGADOR)
	   REFERENCES JUGADORS (ID) ENABLE);

CREATE TABLE CONTRACTES 
  (DATA_INICI DATE NOT NULL ENABLE,
   DATA_FI DATE,
	 JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
	 EQUIP_COMPRADOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
	 EQUIP_VENEDOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
	 DURADA NUMBER(5,0) DEFAULT 365, 
	 SALARI_BRUT NUMBER(15,2) DEFAULT 0, 
	 COMPENSACIO_EQUIP NUMBER(15,2) DEFAULT 0, 
	 TOTAL_OPERACIO NUMBER(15,2) DEFAULT 0, 
	 MONEDA VARCHAR2(3 BYTE) DEFAULT 'EUR', 
	  CONSTRAINT CONTRACTES_PK PRIMARY KEY (DATA_INICI, JUGADOR, EQUIP_COMPRADOR, EQUIP_VENEDOR),
    CONSTRAINT CONTRACTES_FK1 FOREIGN KEY (EQUIP_COMPRADOR)
	   REFERENCES EQUIPS (ID) ENABLE, 
	 CONSTRAINT CONTRACTES_FK2 FOREIGN KEY (EQUIP_VENEDOR)
	   REFERENCES EQUIPS (ID) ENABLE, 
	 CONSTRAINT CONTRACTES_FK3 FOREIGN KEY (JUGADOR)
	   REFERENCES JUGADORS (ID) ENABLE, 
	 CONSTRAINT CONTRACTES_FK4 FOREIGN KEY (MONEDA)
	   REFERENCES MONEDES (ID) ENABLE);

CREATE TABLE PARTITS 
  (ID NUMBER(15,0), 
	 DATA DATE NOT NULL ENABLE, 
	 LLOC VARCHAR2(100 BYTE), 
	 EQUIP_LOCAL VARCHAR2(20 BYTE) NOT NULL ENABLE, 
	 EQUIP_VISITANT VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   COMPETICIO NUMBER(15,0) NOT NULL ENABLE, 
	  CONSTRAINT PARTITS_PK PRIMARY KEY (DATA, EQUIP_LOCAL, EQUIP_VISITANT, COMPETICIO),
    CONSTRAINT PARTITS_FK1 FOREIGN KEY (EQUIP_LOCAL)
	   REFERENCES EQUIPS (ID) ENABLE,
    CONSTRAINT PARTITS_FK2 FOREIGN KEY (EQUIP_VISITANT)
	   REFERENCES EQUIPS (ID) ENABLE);

CREATE TABLE TECNICS 
  (ID VARCHAR2(20 BYTE) NOT NULL ENABLE, 
	 NOM VARCHAR2(100 BYTE), 
	 TIPUS NUMBER(1,0), 
	  CONSTRAINT TECNICS_PK PRIMARY KEY (ID),
	  CONSTRAINT TECNICS_FK1 FOREIGN KEY (TIPUS)
	   REFERENCES TIPUS_TECNICS (ID) ENABLE);

CREATE TABLE JUGADORS_PARTITS
  (JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   PARTIT NUMBER(15,0) NOT NULL ENABLE, 
    CONSTRAINT JUGADORS_PARTITS_PK PRIMARY KEY (JUGADOR, PARTIT),
    CONSTRAINT JUGADORS_PARTITS_FK1 FOREIGN KEY (JUGADOR)
     REFERENCES JUGADORS (ID) ENABLE);
     
CREATE TABLE EQUIPS_TECNICS
  (EQUIP VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   TECNIC VARCHAR2(20 BYTE) NOT NULL ENABLE, 
    CONSTRAINT EQUIPS_TECNICS_PK PRIMARY KEY (EQUIP, TECNIC),
    CONSTRAINT EQUIPS_TECNICS_FK1 FOREIGN KEY (EQUIP)
     REFERENCES EQUIPS (ID) ENABLE, 
    CONSTRAINT EQUIPS_TECNICS_FK2 FOREIGN KEY (TECNIC)
     REFERENCES TECNICS (ID) ENABLE);
     
CREATE TABLE ARBITRES_PARTITS
  (ARBITRE VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   PARTIT NUMBER(15,0) NOT NULL ENABLE, 
    CONSTRAINT ARBITRES_PARTITS_PK PRIMARY KEY (ARBITRE, PARTIT),
    CONSTRAINT ARBITRES_PARTITS_FK1 FOREIGN KEY (ARBITRE)
     REFERENCES ARBITRES (ID) ENABLE);

CREATE TABLE ESTADISTIQUES 
  (JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
	 PARTIT NUMBER(15,0) NOT NULL ENABLE, 
	 MINUTS_JUGATS NUMBER(3,0) DEFAULT 0, 
	 PT NUMBER(3,0) DEFAULT 0, 
	 T1I NUMBER(3,0) DEFAULT 0, 
	 T1E NUMBER(3,0) DEFAULT 0,
   T2I NUMBER(3,0) DEFAULT 0,
   T2E NUMBER(3,0) DEFAULT 0,
   T3I NUMBER(3,0) DEFAULT 0,
   T3E NUMBER(3,0) DEFAULT 0,
   RD NUMBER(3,0) DEFAULT 0,
   RO NUMBER(3,0) DEFAULT 0,
   AST NUMBER(3,0) DEFAULT 0,
   TF NUMBER(3,0) DEFAULT 0,
   TC NUMBER(3,0) DEFAULT 0,
   PR NUMBER(3,0) DEFAULT 0,
   PP NUMBER(3,0) DEFAULT 0,
   FC NUMBER(3,0) DEFAULT 0,
   FR NUMBER(3,0) DEFAULT 0,
   V NUMBER(3,0) DEFAULT 0,
   VP NUMBER(3,0) DEFAULT 0,
    CONSTRAINT ESTADISTIQUES_PK PRIMARY KEY (JUGADOR, PARTIT),
	  CONSTRAINT ESTADISTIQUES_FK1 FOREIGN KEY (JUGADOR)
	   REFERENCES JUGADORS (ID) ENABLE);
     
-- Dimensions i taules de fets necessries pel mdul datawarehouse

-- DIMENSIONS
CREATE TABLE DIM_DATA 
  (ID_DATA NUMBER(8,0) NOT NULL ENABLE, 
	 DATA_ANY VARCHAR2(4), 
	 DATA_MES VARCHAR2(2), 
	 DATA_DIA VARCHAR2(2), 
	  CONSTRAINT DIM_DATA_PK PRIMARY KEY (ID_DATA));
    
CREATE TABLE DIM_JUGADOR
  (ID_JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE,
	  CONSTRAINT DIM_JUGADOR_PK PRIMARY KEY (ID_JUGADOR));

CREATE TABLE DIM_EQUIP
  (ID_EQUIP VARCHAR2(20 BYTE) NOT NULL ENABLE,
	  CONSTRAINT DIM_EQUIP_PK PRIMARY KEY (ID_EQUIP));
    
CREATE TABLE DIM_COMPETICIO 
  (ID_COMPETICIO NUMBER(15,0) NOT NULL ENABLE,
	  CONSTRAINT DIM_COMPETICIO_PK PRIMARY KEY (ID_COMPETICIO));

CREATE TABLE DIM_MODALITAT
  (ID_MODALITAT VARCHAR2(2 BYTE) NOT NULL ENABLE,
	  CONSTRAINT DIM_MODALITAT_PK PRIMARY KEY (ID_MODALITAT));

CREATE TABLE DIM_GENERE
  (ID_GENERE VARCHAR2(1 BYTE) NOT NULL ENABLE,
	  CONSTRAINT DIM_GENERE_PK PRIMARY KEY (ID_GENERE));

CREATE TABLE DIM_PAIS
  (ID_PAIS VARCHAR2(3 BYTE) NOT NULL ENABLE,
	  CONSTRAINT DIM_PAIS_PK PRIMARY KEY (ID_PAIS));

-- TAULES DE FETS
CREATE TABLE JUGADORS_ACTIUS
  (ID_GENERE VARCHAR2(1 BYTE) NOT NULL ENABLE,
   ID_MODALITAT VARCHAR2(2 BYTE) NOT NULL ENABLE,
   NUM_JUGADORS NUMBER(15,0),
	  CONSTRAINT JUGADORS_ACTIUS_PK PRIMARY KEY (ID_GENERE, ID_MODALITAT),
    CONSTRAINT JUGADORS_ACTIUS_FK1 FOREIGN KEY (ID_GENERE)
	   REFERENCES DIM_GENERE (ID_GENERE) ENABLE,
    CONSTRAINT JUGADORS_ACTIUS_FK2 FOREIGN KEY (ID_MODALITAT)
	   REFERENCES DIM_MODALITAT (ID_MODALITAT) ENABLE);

CREATE TABLE MAXIM_ANOTADOR
  (ID_COMPETICIO NUMBER(15,0) NOT NULL ENABLE,
   ID_DATA NUMBER(8,0) NOT NULL ENABLE,
   ID_JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE, 
   PUNTS NUMBER(15,0),
	  CONSTRAINT MAXIM_ANOTADOR_PK PRIMARY KEY (ID_COMPETICIO, ID_DATA, ID_JUGADOR),
    CONSTRAINT MAXIM_ANOTADOR_FK1 FOREIGN KEY (ID_COMPETICIO)
	   REFERENCES DIM_COMPETICIO (ID_COMPETICIO) ENABLE,
    CONSTRAINT MAXIM_ANOTADOR_FK2 FOREIGN KEY (ID_DATA)
	   REFERENCES DIM_DATA (ID_DATA) ENABLE,
    CONSTRAINT MAXIM_ANOTADOR_FK3 FOREIGN KEY (ID_JUGADOR)
	   REFERENCES DIM_JUGADOR (ID_JUGADOR) ENABLE);

CREATE TABLE JUGADOR_MES_BEN_PAGAT
  (ID_MODALITAT VARCHAR2(2 BYTE) NOT NULL ENABLE,
   ID_GENERE VARCHAR2(1 BYTE) NOT NULL ENABLE,
   ID_JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE,
   SOU NUMBER (15,2),
	  CONSTRAINT JUGADORS_MES_BEN_PAGAT_PK PRIMARY KEY (ID_MODALITAT, ID_GENERE, ID_JUGADOR),
    CONSTRAINT JUGADORS_MES_BEN_PAGAT_FK1 FOREIGN KEY (ID_MODALITAT)
	   REFERENCES DIM_MODALITAT (ID_MODALITAT) ENABLE,
    CONSTRAINT JUGADORS_MES_BEN_PAGAT_FK2 FOREIGN KEY (ID_GENERE)
	   REFERENCES DIM_GENERE (ID_GENERE) ENABLE,
    CONSTRAINT JUGADORS_MES_BEN_PAGAT_FK3 FOREIGN KEY (ID_JUGADOR)
	   REFERENCES DIM_JUGADOR (ID_JUGADOR) ENABLE); 
     
CREATE TABLE JUGADOR_MES_GUANY
  (ID_JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE,
   GUANYS NUMBER(15,2),
	  CONSTRAINT JUGADOR_MES_GUANY_PK PRIMARY KEY (ID_JUGADOR),
    CONSTRAINT JUGADOR_MES_GUANY_FK1 FOREIGN KEY (ID_JUGADOR)
	   REFERENCES DIM_JUGADOR (ID_JUGADOR) ENABLE);

CREATE TABLE RANKING_SOU_MIG
  (ID_PAIS VARCHAR2(3 BYTE) NOT NULL ENABLE,
   ID_DATA NUMBER(8,0) NOT NULL ENABLE,
   ID_GENERE VARCHAR2(1 BYTE) NOT NULL ENABLE,
   ID_MODALITAT VARCHAR2(2 BYTE) NOT NULL ENABLE,
   SOU_MIG NUMBER (15,2),
	  CONSTRAINT RANKING_SOU_MIG_PK PRIMARY KEY (ID_PAIS, ID_DATA, ID_GENERE, ID_MODALITAT),
    CONSTRAINT RANKING_SOU_MIG_FK1 FOREIGN KEY (ID_PAIS)
	   REFERENCES DIM_PAIS (ID_PAIS) ENABLE,
    CONSTRAINT RANKING_SOU_MIG_FK2 FOREIGN KEY (ID_DATA)
	   REFERENCES DIM_DATA (ID_DATA) ENABLE,
    CONSTRAINT RANKING_SOU_MIG_FK3 FOREIGN KEY (ID_GENERE)
	   REFERENCES DIM_GENERE (ID_GENERE) ENABLE,
    CONSTRAINT RANKING_SOU_MIG_FK4 FOREIGN KEY (ID_MODALITAT)
	   REFERENCES DIM_MODALITAT (ID_MODALITAT) ENABLE);

CREATE TABLE MILLORS_EQUIPS
  (ID_COMPETICIO NUMBER(15,0) NOT NULL ENABLE,
   ID_DATA NUMBER(8,0) NOT NULL ENABLE,
   ID_EQUIP VARCHAR2(20 BYTE) NOT NULL ENABLE,
   PUNTS_MARCATS NUMBER (15,0),
   PUNTS_REBUTS NUMBER (15,0),
	  CONSTRAINT MILLORS_EQUIPS_PK PRIMARY KEY (ID_COMPETICIO, ID_DATA, ID_EQUIP),
    CONSTRAINT MILLORS_EQUIPS_FK1 FOREIGN KEY (ID_COMPETICIO)
	   REFERENCES DIM_COMPETICIO (ID_COMPETICIO) ENABLE,
    CONSTRAINT MILLORS_EQUIPS_FK2 FOREIGN KEY (ID_DATA)
	   REFERENCES DIM_DATA (ID_DATA) ENABLE,
    CONSTRAINT MILLORS_EQUIPS_FK3 FOREIGN KEY (ID_EQUIP)
	   REFERENCES DIM_EQUIP (ID_EQUIP) ENABLE);

CREATE TABLE MILLOR_JUGADOR
  (ID_GENERE VARCHAR2(1 BYTE) NOT NULL ENABLE,
   ID_MODALITAT VARCHAR2(2 BYTE) NOT NULL ENABLE,
   ID_JUGADOR VARCHAR2(20 BYTE) NOT NULL ENABLE,
   VP NUMBER(15,0),
	  CONSTRAINT MILLOR_JUGADOR_PK PRIMARY KEY (ID_GENERE, ID_MODALITAT, ID_JUGADOR),
    CONSTRAINT MILLOR_JUGADOR_FK1 FOREIGN KEY (ID_GENERE)
	   REFERENCES DIM_GENERE (ID_GENERE) ENABLE,
    CONSTRAINT MILLOR_JUGADOR_FK2 FOREIGN KEY (ID_MODALITAT)
	   REFERENCES DIM_MODALITAT (ID_MODALITAT) ENABLE,
    CONSTRAINT MILLOR_JUGADOR_FK3 FOREIGN KEY (ID_JUGADOR)
	   REFERENCES DIM_JUGADOR (ID_JUGADOR) ENABLE);

CREATE TABLE CONTROL_DWH
 (PROCEDIMENT VARCHAR2(50) NOT NULL ENABLE,
  DATA_INICI_DARR_EXEC DATE,
  DATA_FI_DARR_EXEC DATE,
  DATA_EXEC DATE,
	CONSTRAINT controldwh_pk PRIMARY KEY(procediment));

--Taules necessries pel mdul de control

CREATE TABLE LOG_PROC_EXEC
  (ID NUMBER(15,0) NOT NULL ENABLE,
   PROCEDIMENT VARCHAR2(100) NOT NULL ENABLE,
   PARAMETRES VARCHAR2(512) NOT NULL ENABLE,
    CONSTRAINT LOG_PROC_EXEC_PK  PRIMARY KEY (ID));
		
CREATE TABLE LOG_PROC_HIST_EXEC
  (ID NUMBER(15,0) NOT NULL ENABLE,
   DATA DATE NOT NULL ENABLE,
	 OPERACIO VARCHAR2(512) NOT NULL ENABLE,
    CONSTRAINT LOG_PROC_HIST_EXEC_FK FOREIGN KEY (ID)
     REFERENCES LOG_PROC_EXEC(ID));

CREATE TABLE CONFIG_SISTEMA
  (PARAMETRE VARCHAR2(20) NOT NULL ENABLE,
   VALOR VARCHAR2(20) NOT NULL ENABLE,
    CONSTRAINT CONFIG_SISTEMA_PK PRIMARY KEY (PARAMETRE));

spool off;



